//
// Lol Engine
//
// Copyright: (c) 2010-2013 Sam Hocevar <sam@hocevar.net>
//   This program is free software; you can redistribute it and/or
//   modify it under the terms of the Do What The Fuck You Want To
//   Public License, Version 2, as published by Sam Hocevar. See
//   http://www.wtfpl.net/ for more details.
//

#include <lol/engine-internal.h>

#include <string>

#include "gpu/lolfx-compiler.h"

namespace lol
{

LolFxCompiler::LolFxCompiler(LolFx &lolfx)
    : m_lolfx(lolfx)
{
}

bool LolFxCompiler::ParseString(char const *command)
{
    LolFxScanner scanner(command);
    m_lexer = &scanner;
    LolFxParser parser(*this);
    //parser.set_debug_level(1);
    if (parser.parse() != 0)
        return false;
    return true;
}

void LolFxCompiler::Error(const class location& l, const std::string& m)
{
    Log::Error("LolFx syntax error line %d column %d: %s\n",
               l.begin.line, l.begin.column, m.c_str());
}

void LolFxCompiler::Error(const std::string& m)
{
    Log::Error("LolFx syntax error: %s\n", m.c_str());
}

} /* namespace lol */

